/*
 * Copyright (c) 2005 Dmirty Alexandrov aka dimzon aka dimzon541 (dimzon541@gmail.com)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

#include <windows.h>
#include <stdio.h>

#define BSE_API extern "C"  __declspec(dllexport)
#define BUF_SIZE 16000

char * g_s_BSE_Description=NULL;

void About(char* s);
int Init(
		 int nSampleRate,
		 int nChannelsCount,
		 int nBitsPerSample,
		 char * sOutFileName,
		 char** argv,int argc,
		 char * sDescription,
		 char * err
		 );

int Encode(
		 unsigned char * aRawPCM,
		 size_t nSize,
		 char * err
		 );

int Done(char * err);


BSE_API void BSN_DeInit(void)
{
	char buf[BUF_SIZE];memset(buf,0,sizeof(buf));
	int nResult = Done(buf);
	if(nResult==0) return;
	fprintf(stdout,"\nError: %d\n%s", nResult, buf);
	ExitProcess(nResult);
}


BSE_API int BSN_EncodeBlock(unsigned char* pBuf,size_t blockSizeRead)
{
	char buf[BUF_SIZE];memset(buf,0,sizeof(buf));
	int nResult = Encode(pBuf, blockSizeRead, buf);
	if(nResult==0) return 0;
	fprintf(stdout,"\nError: %d\n%s", nResult, buf);
	ExitProcess(nResult);
	return -1;
}


BSE_API int BSN_Init(int* SampleRate, int ChannelsCount,char* OutFileName,int BitsPerSample,int ShowDialog,char* path,char** argv,int argc)
{
	char buf[BUF_SIZE];memset(buf,0,sizeof(buf));
	char dsc[BUF_SIZE];memset(dsc,0,sizeof(dsc));
	int nResult = Init(* SampleRate, ChannelsCount, BitsPerSample, OutFileName, argv, argc, dsc, buf);
	if(nResult==0) 
	{
		g_s_BSE_Description = strdup(dsc);
		if(buf[0]!=0) fprintf(stdout,"\n%s\n", dsc);
		return 0;
	}
	fprintf(stdout,"\nError: %d\n%s", nResult, buf);
	return -1;
}

BSE_API const char* BS_About(int *encoder)
{
	*encoder=0;
	char buf[BUF_SIZE];memset(buf,0,sizeof(buf));
	About(buf);
	return strdup(buf);
}

BSE_API void * BSN_TaggerInit(char* filename,int* FileLength)
{
	return NULL;
}

BSE_API void BSN_TaggerSetup(void* ptr, int type)
{
}

BSE_API int BSN_TaggerDO(int back)
{
	return 1;
}


BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}

BSE_API int BSN_Echo(char* c)
{
	int i1=245;
	i1+=245;
	static char * p = g_s_BSE_Description;
	if(*p==0) return 0;
	for(int i=0;*p!='\n' && *p!=0 && i<60; *c++=*p++, ++i);
	*c=0;
	return 1;
}
